<?php

/*****************************************************************************
 * cmi (Copyright Management Information) Plugin for Geeklog                 *
 * Copyright (C) 2004 by the following authors:                              *
 * Authors: Mike Green <mikey at badpenguins dot com>                        *
 *****************************************************************************
 * functions.inc                                                             *
 * This file implements the needed geeklog plugin api methods and contains   *
 * all of the common code needed by the cmi plugin.                          *
 *****************************************************************************
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    *
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *****************************************************************************/
$langfile = $_CONF['path'] . 'plugins/cmi/language/' . $_CONF['language']
    . '.php';
if (file_exists ($langfile)) {
    include ($langfile);
    } else {
    include ($_CONF['path'] . 'plugins/cmi/language/english.php');
    }
include ($_CONF['path'] . 'plugins/cmi/config.php');

/*****************************************************************************
 *****************************************************************************
 **** Begin Geeklog Plugin API Implementation                             ****
 *****************************************************************************
 *****************************************************************************/
// comments not supported (yet)
function plugin_commentsupport_cmi() {
    return false;
    }

/*****************************************************************************
 * Add entry to admin block                                                  *
 *****************************************************************************/
function plugin_getadminoption_cmi() {

global $_CONF, $LANG_CMI, $_TABLES;

if (SEC_hasRights('cmi.add,cmi.delete,cmi.edit','OR')) {
    $url = $_CONF['site_admin_url'] . '/plugins/cmi/index.php';
    return array($LANG_CMI[15],$url,DB_count($_TABLES['cmi_licenses']));
    }

}

/*****************************************************************************
 * Allow searching of licens type                                            *
 *****************************************************************************/
function plugin_searchtypes_cmi() {

return false;

}

/*****************************************************************************
 * uninstall (called by failed install)                                      *
 *****************************************************************************/
function plugin_uninstall_cmi($steps='') {

global $_TABLES, $_CMI_CONF;

if (!SEC_inGroup('Root')) {
    $msg  = "Someone has attempted to illegally uninstall the cmi plugin.  ";
    $msg .= "User id: {$_USER['uid']}, Username: {$_USER['username']},";
    $msg .= " IP: $REMOTE_ADDR";
    COM_errorLog($msg,1);
    $display  = COM_siteHeader();
    $display .= COM_startBlock($LANG_CMI[1]);
    $display .= $LANG_CMI[2];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
    exit();
    }

// Uninstall the tables
if (empty($steps) OR $steps['createtable1'] === true) {
    $table = $_TABLES['cmi_licenses'];
    COM_errorLog("Dropping table $table",1);
    DB_query("DROP TABLE $table");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }

// back off comments table changes
if (empty($steps) OR $steps['altercommentstable'] === true or
    $steps['commentstableindex'] === true) {
    $table = $_TABLES['comments'];
    COM_errorLog("Dropping lid from comments table",1);
    DB_QUERY("ALTER TABLE $table drop lid");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }

// back off stories table changes
if (empty($steps) OR $steps['alterstoriestable'] === true or
    $steps['storiestableindex'] === true) {
    $table = $_TABLES['stories'];
    COM_errorLog("Dropping lid from stories table",1);
    DB_QUERY("ALTER TABLE $table drop lid");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }

// back off submissions table changes
if (empty($steps) OR $steps['altersubmissiontable'] === true) {
    $table = $_TABLES['storysubmission'];
    COM_errorLog("Dropping lid from submissions table",1);
    DB_QUERY("ALTER TABLE $table drop lid");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }

// get group information
$a_group    = $_CMI_CONF['cmi_admin_group'];
$a_group_id = DB_getItem($_TABLES['groups'],'grp_id',"grp_name='$a_group'");
$m_group    = $_CMI_CONF['cmi_mod_group'];
$m_group_id = DB_getItem($_TABLES['groups'],'grp_id',"grp_name='$m_group'");
// get perm information
$add_id     = DB_getItem($_TABLES['features'],'ft_id',"ft_name='cmi.add'");
$delete_id  = DB_getItem($_TABLES['features'],'ft_id',"ft_name='cmi.delete'");
$edit_id    = DB_getItem($_TABLES['features'],'ft_id',"ft_name='cmi.edit'");
$list_id    = DB_getItem($_TABLES['features'],'ft_id',"ft_name='cmi.list'");

// revoke add perms
if (empty($steps) or $steps['grantadminadd'] or $steps['grantmodadd']) {
    COM_errorLog('Attempting to revoke cmi.add rights from all groups',1);
    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id=$add_id");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }
// revoke delete perms
if (empty($steps) or $steps['grantadmindelete'] or $steps['grantmoddelete']) {
    COM_errorLog('Attempting to revoke cmi.delete rights from all groups',1);
    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id=$delete_id");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }
// revoke edit perms
if (empty($steps) or $steps['grantadminedit'] or $steps['grantmodedit']) {
    COM_errorLog('Attempting to revoke cmi.edit rights from all groups',1);
    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id=$edit_id");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }
// revoke list perms
if (empty($steps) or $steps['grantalllist']) {
    COM_errorLog('Attempting to revoke cmi.list rights from all groups',1);
    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id=$list_id");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }

// remove root users from admin group
if (empty($steps) OR $steps['addedrootuserstoadmin'] === true) {
    COM_errorLog("Attempting to remove root users from $a_group group");
    $sql  = "DELETE FROM {$_TABLES['group_assignments']} ";
    $sql .= "WHERE ug_main_grp_id=$a_group_id";
    DB_query($sql);
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }

// remove root users from mod group
if (empty($steps) OR $steps['addedrootuserstomod'] === true) {
    COM_errorLog("Attempting to remove root users from $m_group group");
    $sql  = "DELETE FROM {$_TABLES['group_assignments']} ";
    $sql .= "WHERE ug_main_grp_id=$m_group_id";
    DB_query($sql);
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }

// Remove admin group
if (empty($steps) OR $steps['insertadmingroup'] === true) {
    COM_errorLog("Attempting to remove group: $a_group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $a_group_id");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }
// Remove mod group
if (empty($steps) OR $steps['insertmodgroup'] === true) {
    COM_errorLog("Attempting to remove group: $m_group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id=$m_group_id");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }

// get info to remove perms
$add_id    = DB_getItem($_TABLES['features'],'ft_id',"ft_name='cmi.add'");
$edit_id   = DB_getItem($_TABLES['features'],'ft_id',"ft_name='cmi.edit'");
$delete_id = DB_getItem($_TABLES['features'],'ft_id',"ft_name='cmi.delete'");
$list_id   = DB_getItem($_TABLES['features'],'ft_id',"ft_name='cmi.list'");
// remove add perms
if (empty($steps) OR $steps['insertedaddperm'] == 1) {
    COM_errorLog('Attempting to remove the cmi.add perm',1);
    DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id=$add_id");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }
// remove edit perms
if (empty($steps) OR $steps['insertededitperm'] == 1) {
    COM_errorLog('Attempting to remove the cmi.edit perm',1);
    DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id=$edit_id");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }
// remove delete perms
if (empty($steps) OR $steps['inserteddeleteperm'] == 1) {
    COM_errorLog('Attempting to remove the cmi.delete perm',1);
    DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id=$delete_id");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }
// remove list perms
if (empty($steps) OR $steps['insertedlistperm'] == 1) {
    COM_errorLog('Attempting to remove the cmi.list perm',1);
    DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $list_id");
    if (DB_error()) {
        COM_errorLog('...failed',1);
        } else {
        COM_errorLog('...success',1);
        }
    }

// Unregister the plugin with Geeklog
COM_errorLog('Attempting to unregister the plugin from Geeklog',1);
DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'cmi'");
if (DB_error()) {
    COM_errorLog('...failed',1);
    } else {
    COM_errorLog('...success',1);
    }

COM_errorLog('leaving plugin_uninstall_cmi',1);

return true;

}

/*****************************************************************************
 *****************************************************************************
 **** End Geeklog Plugin API Implementation                               ****
 *****************************************************************************
 *****************************************************************************/

/*****************************************************************************
 * cmi_authorSelect()                                                        *
 *****************************************************************************/
function cmi_authorSelect($default=1,$field='uid') {

if (!SEC_hasRights("cmi.edit")) { return ''; }

global $_TABLES;

$retval     = '';

$sql  = "select uid,username from {$_TABLES['users']} order by username";
$results = DB_query($sql);
if (DB_error()) { return ''; }
$nrows = DB_numRows($results);
if ($nrows < 1) { return ''; }

if ($field !== "uid" and $field !== "aid") { return ''; }

$retval .= "<select name=\"$field\">";
for($j=0; $j < $nrows; $j++) {
    $A = db_fetchArray($results);
    $uid = $A['uid'];
    $un  = stripslashes($A['username']);
    if ($uid == $default) {
        $opt = "option selected";
        } else {
        $opt = "option";
        }
    $retval .= "<$opt value=\"$uid\">$un";
    }

$retval .= "</select>";

return $retval;

}

/*****************************************************************************
 * Performs updates to comment CMI                                           *
 *****************************************************************************/
function cmi_commentEdit($c_id='',$l_id='',$a_id='') {

cmi_validateCommentEdit($c_id,$l_id,$a_id);

global $_TABLES, $LANG_STATIC, $LANG_CMI, $_CONF;

$retval = '';

$sql  = "UPDATE " . $_TABLES['comments'] . " set uid=$a_id, lid=$l_id ";
$sql .= "where cid=$c_id LIMIT 1";
DB_query($sql);
if (DB_error()) {
    $retval .= COM_startBlock($LANG_CMI[66]);
    $retval .= $LANG_CMI[67];
    $retval .= COM_endBlock();
    $retval .= COM_siteFooter();
    $msg  = "User {$_USER['username']} tried to edit comment CMI ";
    $msg .= "and experienced a query failure. IP: " . $_SERVER['REMOTE_ADDR'];
    COM_accessLog($msg);
    } else {
    $retval .= COM_startBlock($LANG_CMI[65]);
    $retval .= $LANG_CMI[68];
    $retval .= COM_endBlock();
    $retval .= COM_siteFooter();
    $msg  = "User {$_USER['username']} changed comment CMI. ";
    $msg .= "comment: $c_id author: $a_id license: $l_id IP: ";
    $msg .= $_SERVER['REMOTE_ADDR'];
    COM_accessLog($msg);
    }

return $retval;

}

/*****************************************************************************
 * Displays a form for editing comment cmi
 *****************************************************************************/
function cmi_commentEditForm($c_id='',$l_id='',$a_id='') {

cmi_validateCommentEdit($c_id,$l_id,$a_id);

global $_TABLES, $LANG_STATIC, $LANG_CMI, $_CONF;

$retval = '';

$TPL = new Template($_CONF['path'] . 'plugins/cmi/templates/admin');
$TPL->set_file('page','comment.edit.thtml');
$TPL->set_var('start_block_edit',COM_startBlock($LANG_CMI[65]));
$TPL->set_var('cid',$c_id);
$TPL->set_var('submit_url',$_CONF['site_admin_url']
              . '/plugins/cmi/index.php');
$TPL->set_var('author_select',cmi_authorSelect($a_id,"aid"));
$TPL->set_var('license_select',cmi_licenseSelect($l_id));
$TPL->set_var('end_block',COM_endBlock());
$TPL->parse('output','page');
$retval .= $TPL->finish($TPL->get_var('output'));

return $retval;

}

/*****************************************************************************
 * cmi_displayArticleLicenseLink()                                           *
 * Displays the license name and url if applicable when viewing an article.  *
 *****************************************************************************/
function cmi_displayArticleLicenseLink($license_id=1) {

if (!SEC_hasRights('cmi.add,cmi.delete,cmi.edit,cmi.list','OR')) {
    return '';
    }

global $_TABLES;

if (!is_numeric($license_id)) { return ''; }

$sql = "select * from {$_TABLES['cmi_licenses']} where lid=$license_id limit 1";
$qid = DB_query($sql);
if (DB_error() or DB_numRows($qid) < 1) {
    return '';
    }
$A = db_fetchArray($qid);

$retval = '';
$license_name = stripslashes($A['license_name']);
$license_url  = stripslashes($A['license_url']);
$license_ver  = stripslashes($A['license_version']);
if (empty($license_name) or $license_name == '')   { return ''; }

if (!empty($license_url)) {
    $retval .= "<a href=\"{$license_url}\">";
    $retval .= "{$license_name} {$license_ver}</a>";
    } else {
    $retval  =  "$license_name $license_ver";
    }

return $retval;

}

/*****************************************************************************
 * cmi_displayCommentEditLink()                                              *
 * Displays the CMI Edit link for comments                                   *
 *****************************************************************************/
function cmi_displayCommentEditLink($c_id='',$l_id='',$a_id='') {

if (!SEC_hasRights('cmi.edit')) { return ''; }
if (!is_numeric($c_id) or !is_numeric($l_id) or !is_numeric($a_id)) {
    return '';
}

global $_CONF;

$url   = $_CONF['site_admin_url'] . '/plugins/cmi/index.php';
$url  .= "?ot=cmi&amp;mode=edit&amp;cid={$c_id}&amp;lid={$l_id}&amp;";
$url  .= "aid={$a_id}";
$href  = "<a href=\"$url\">Edit CMI</a>";

return $href;

}

/*****************************************************************************
 * cmi_displayCommentLicenseLink()                                           *
 * Displays the license name and url if applicable when viewing the comment. *
 *****************************************************************************/
function cmi_displayCommentLicenseLink($comment_ar='') {

global $_USER;

if (!SEC_hasRights('cmi.add,cmi.delete,cmi.edit,cmi.list','OR')) {
    return '';
    }

if (!array_key_exists('license_name',$comment_ar)) { return ''; }

$cid = $comment_ar['cid'];
$uid = $comment_ar['uid'];
$lid = $comment_ar['lid'];

$retval = '';
$license_name = stripslashes($comment_ar['license_name']);
$license_url  = stripslashes($comment_ar['license_url']);
$license_ver  = stripslashes($comment_ar['license_version']);
if (empty($license_name) or $license_name == '')   { return ''; }

if (!empty($license_url)) {
    $retval .= " [ License: ";
    $retval .= "<a target=\"_new\" href=\"{$license_url}\">";
    $retval .= "{$license_name} {$license_ver}</a> ] ";
    } else {
    $retval  =  " [ License: $license_name $license_ver ] ";
    }

return $retval;

}

/*****************************************************************************
 * cmi_generateAdminLinks()                                                  *
 * Generates the list of links at the top of admin menu blocks.              *
 *****************************************************************************/
function cmi_generateAdminLinks() {

global $_CONF;

// cmi admin home
$cmi_admin_url     = "{$_CONF['site_admin_url']}/plugins/cmi/index.php";
$cmi_admin_href    = "<a href=\"$cmi_admin_url\">CMI Admin</a>";
// list licenses
$list_license_url  = "{$cmi_admin_url}?mode=list&ot=license";
$list_license_href = "<a href=\"$list_license_url\">List Licenses</a>";
// add license
$add_license_url   = "{$cmi_admin_url}?mode=add&ot=license";
$add_license_href  = "<a href=\"$add_license_url\">Add License</a>";

$menu_hrefs   = array();
$menu_hrefs[] = $cmi_admin_href;
if (SEC_hasRights('cmi.list')) {
    $menu_hrefs[] = $list_license_href;
    }
if (SEC_hasRights('cmi.add')) {
    $menu_hrefs[] = $add_license_href;
    }

return '[ ' . implode(' | ',$menu_hrefs) . ' ]';


}

/*****************************************************************************
 * cmi_licenseAdd()                                                          *
 * Accepts form input needed to add a license to the system.                 *
 *****************************************************************************/
function cmi_licenseAdd($pvars='') {

cmi_validateLicenseAdd($pvars,true);

global $_TABLES, $_CMI_CONF, $LANG_CMI, $_CONF, $_USER;

$retval     = '';
$fields     = $pvars['fields'];
$field_list = array();
$value_list = array();

while($field_value = current($fields)) {
    $key_name    = key($fields);
    $field_value = addslashes(COM_checkHTML($field_value));
    switch($key_name) {
        case "ln":
            $field_list[] = "license_name";
            $value_list[] = "'$field_value'";
        break;
        case "lv":
            $field_list[] = "license_version";
            $value_list[] = "'$field_value'";
        break;
        case "lu":
            $field_list[] = "license_url";
            $value_list[] = "'$field_value'";
        break;
        case "lt":
            $field_list[] = "license_text";
            $value_list[] = "'$field_value'";
        break;
        }
    next($fields);
    }

// add a time stamp
$field_list[] = 'tstamp';
$value_list[] = 'now()';

$field_list = implode(',',$field_list);
$value_list = implode(',',$value_list);
DB_save($_TABLES['cmi_licenses'],$field_list,$value_list);

return COM_refresh($_CONF['site_admin_url']
    . '/plugins/cmi/index.php');

}

/*****************************************************************************
 * cmi_licenseDelete()                                                       *
 * Accepts form input needed to add a license to the system.                 *
 *****************************************************************************/
function cmi_licenseDelete($pvars='') {

cmi_validateLicenseDelete($pvars,true);

global $_TABLES, $_USER, $LANG_STATIC, $LANG_CMI, $_CONF;

$license_id = addslashes($pvars['lid']);
$sql  = "DELETE FROM " . $_TABLES['cmi_licenses'];
$sql .= " WHERE lid=$license_id limit 1";
DB_query($sql);
if (DB_error()) {
    $msg1  = "Failed to delete license_id $license_id.  ";
    $msg1 .= "User: {$_USER['username']} IP: {$_SERVER['REMOTE_ADDR']}";
    $msg2  = "License may not have been deleted due to a SQL error.";
    COM_errorLog($msg1,1);
    } else {
    $msg1  = "User {$_USER['username']} deleted license_id $license_id.  ";
    $msg1 .= "IP: {$_SERVER['REMOTE_ADDR']}";
    $msg2  = "License deleted";
    COM_errorLog($msg1,1);
    }

return COM_refresh($_CONF['site_admin_url'] . '/plugins/cmi/index.php');

}

/*****************************************************************************
 * cmi_licenseEdit()                                                         *
 * Accepts form input needed to add a license to the system.                 *
 *****************************************************************************/
function cmi_licenseEdit($pvars='') {

cmi_validateLicenseEdit($pvars,true);

global $_TABLES, $_CMI_CONF, $LANG_CMI, $_CONF, $_USER;

$retval     = '';
$fields     = $pvars['fields'];
$license_id = addslashes($pvars['lid']);
$field_list = array();
$value_list = array();

while($field_value = current($fields)) {
    $key_name    = key($fields);
    $field_value = addslashes(COM_checkHTML($field_value));
    switch($key_name) {
        case "ln":
            $value_list[] = "license_name='$field_value'";
        break;
        case "lv":
            $value_list[] = "license_version='$field_value'";
        break;
        case "lu":
            $value_list[] = "license_url='$field_value'";
        break;
        case "lt":
            $value_list[] = "license_text='$field_value'";
        break;
        }
    next($fields);
    }

$value_list = implode(',',$value_list);
$sql  = "UPDATE " . $_TABLES['cmi_licenses'] . " set $value_list ";
$sql .= "where lid=$license_id LIMIT 1";
DB_query($sql);

return COM_refresh($_CONF['site_admin_url']
    . '/plugins/cmi/index.php');

}

/*****************************************************************************
 * cmi_licenseEdit()                                                         *
 * Accepts form input needed to add a license to the system.                 *
 *****************************************************************************/
function cmi_licenseSelect($default=1) {

if (!SEC_hasRights("cmi.list")) { return ''; }

global $_TABLES;

$retval     = '';

$sql  = "select lid,license_name,license_version from ";
$sql .= "{$_TABLES['cmi_licenses']} order by license_name,license_version";
$results = DB_query($sql);
if (DB_error()) { return ''; }
$nrows = DB_numRows($results);
if ($nrows < 1) { return ''; }

$retval .= '<select name="lid">';
for($j=0; $j < $nrows; $j++) {
    $A = db_fetchArray($results);
    $lid = $A['lid'];
    $ln  = stripslashes($A['license_name']);
    $lv  = stripslashes($A['license_version']);
    if ($lid == $default) {
        $opt = "option selected";
        } else {
        $opt = "option";
        }
    $retval .= "<$opt value=\"$lid\">$ln $lv";
    }

$retval .= "</select>";

return $retval;

}

/*****************************************************************************
 * Simple stub function to call to verify this plugin in installed.          *
 *****************************************************************************/
function cmi_plugin_exists() {

return true;

}

/*****************************************************************************
 * Called to validate edits of comment cmi                                   *
 *****************************************************************************/
function cmi_validateCommentEdit($c_id='',$l_id='',$a_id='') {

global $_TABLES, $_USER, $LANG_CMI;

if (!SEC_hasRights('cmi.edit')) {
    $display  = COM_siteHeader('menu');
    $display .= COM_startBlock($LANG_CMI[1]);
    $display .= $LANG_CMI[2];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    $msg  = "User {$_USER['username']} tried to edit comment CMI ";
    $msg .= "without cmi.edit perms. IP: " . $_SERVER['REMOTE_ADDR'];
    COM_accessLog($msg);
    echo $display;
    exit();
    }

$comment_id   = addslashes($c_id);
$license_id   = addslashes($l_id);
$author_id    = addslashes($a_id);

$invalid_msg  = COM_siteHeader('none');
$invalid_msg .= COM_startBlock($LANG_CMI[60]);
$invalid_msg .= $LANG_CMI[61];
$invalid_msg .= COM_endBlock();
$invalid_msg .= COM_siteFooter();

if (!is_numeric($comment_id) or !is_numeric($license_id) or
    !is_numeric($author_id)) {
    echo $invalid_msg;
    exit();
    }

$count1 = DB_count($_TABLES['comments'],'cid',$comment_id);
if (DB_error()) { die($invalid_msg); }
$count2 = DB_count($_TABLES['cmi_licenses'],'lid',$license_id);
if (DB_error()) { die($invalid_msg); }
$count3 = DB_count($_TABLES['users'],'uid',$author_id);
if (DB_error()) { die($invalid_msg); }
if ($count1 != 1 or $count2 != 1 or $count3 != 1) {
    echo $invalid_msg;
    exit();
    }

}

/*****************************************************************************
 * Called to validate adding a license.                                      *
 *****************************************************************************/
function cmi_validateLicenseAdd($pvars='',$confirm=true) {

global $_USER, $LANG_CMI, $_CMI_CONF;

if (!SEC_hasRights('cmi.add')) {
    $display = COM_siteHeader('menu');
    $display .= COM_startBlock($LANG_CMI[1]);
    $display .= $LANG_CMI[2];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    $msg  = "User {$_USER['username']} was denied access when attempting to ";
    $msg .= "add a license through the CMI plugin.  They need cmi.add perms ";
    $msg .= "to do this.  IP: " . $_SERVER['REMOTE_ADDR'];
    COM_accessLog($msg);
    echo $display;
    exit();
    }
if ($confirm === false) {
    return;
    }
$fields = $pvars['fields'];
if (!is_array($fields)) {
    $display  = COM_siteHeader('menu');
    $display .= COM_startBlock("Error");
    $display .= "You have attempted to add a license with absolutely no ";
    $display .= "information.  Fill in the required fields and try again.";
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    $msg  = "User {$_USER['username']} generated an error when attempting ";
    $msg .= "to add a license through the CMI plugin.  There was no form ";
    $msg .= "data.  IP: " . $_SERVER['REMOTE_ADDR'];
    COM_errorLog($msg);
    echo $display;
    exit();
    }

// verify the required fields are present
$field_list = array();
while($field_value = current($fields)) {
    $key_name = key($fields);
    switch($key_name) {
        case "ln":
            $field_list[] = "license_name";
        break;
        case "lv":
            $field_list[] = "license_version";
        break;
        case "lu":
            $field_list[] = "license_url";
        break;
        case "lt":
            $field_list[] = "license_text";
        break;
        }
    next($fields);
    }

$fields_ok = true;
$required  = $_CMI_CONF['cmi_licenses']['required_fields'];
foreach ($required as $field) {
    if (!in_array($field,$field_list)) {
        $fields_ok     = false;
        $missing_field = $field;
        }
    }

if ($fields_ok === false) {
    $display  = COM_siteHeader('menu');
    $display .= COM_startBlock("Error: Required Field Missing");
    $display .= "The license cannot be added.  The following required field ";
    $display .= "is blank or missing: $missing_field.  Fill in the required ";
    $display .= "fields and try again.";
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    $msg  = "User {$_USER['username']} generated an error when attempting ";
    $msg .= "to add a license through the CMI plugin.  The following ";
    $msg .= "required field was missing: $missing_field.  ";
    $msg .= "IP: " . $_SERVER['REMOTE_ADDR'];
    COM_errorLog($msg);
    echo $display;
    exit();
    }

}

/*****************************************************************************
 * Called to validate the deletion of a license.                             *
 *****************************************************************************/
function cmi_validateLicenseDelete($pvars='',$confirm=true) {

global $_TABLES, $_USER, $LANG_CMI, $_CONF;

if (!SEC_hasRights('cmi.delete')) {
    $display = COM_siteHeader('menu');
    $display .= COM_startBlock($LANG_CMI[1]);
    $display .= $LANG_CMI[2];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    $msg  = "User {$_USER['username']} was denied access when attempting to ";
    $msg .= "delete a license through the CMI plugin.  They need cmi.delete ";
    $msg .= "perms to do this.  IP: {$_SERVER['REMOTE_ADDR']}";
    COM_accessLog($msg);
    echo $display;
    exit();
    }

$license_id   = addslashes($pvars['lid']);
$invalid_msg  = COM_siteHeader('menu');
$invalid_msg .= COM_startBlock($LANG_CMI[60]);
$invalid_msg .= $LANG_CMI[61];
$invalid_msg .= COM_endBlock();
$invalid_msg .= COM_siteFooter();

if (!is_array($pvars) or !is_numeric($license_id)) {
    echo $invalid_msg;
    exit();
    }
if ($confirm === true) {
    if ($pvars['submit'] !== "confirm") {
        echo $invalid_msg;
        exit();
        }
    }
$count = DB_count($_TABLES['cmi_licenses'],'lid',$license_id);
if (DB_error() or $count != 1) {
    echo $invalid_msg;
    exit();
    }

// Can't delete the default license!
if ($license_id == 1) {
    $display  = COM_siteHeader('menu');
    $display .= COM_startBlock('Delete Error');
    $display .= "Sorry, cannot delete the default license.";
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
    exit();
    }

// Do not allow delete if license is currently being used by
// a story, story submission, or comment.
$st_count = DB_count($_TABLES['stories'],'lid',$license_id);
$su_count = DB_count($_TABLES['storysubmission'],'lid',$license_id);
$co_count = DB_count($_TABLES['comments'],'lid',$license_id);
if ($st_count > 0 or $su_count > 0 or $co_count > 0) {
    $display  = COM_siteHeader('menu');
    $display .= COM_startBlock('License In Use');
    $display .= "Sorry, cannot delete a license that is currently in use by ";
    $display .= "a story, story submission, or comment.<br>";
    $display .= "License in use by:<br>";
    $display .= "Stories: $st_count<br>Submissions: $su_count<br>";
    $display .= "Comments: $co_count";
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
    exit();
    }
}

/*****************************************************************************
 * Called to validate edits of a license.                                    *
 *****************************************************************************/
function cmi_validateLicenseEdit($pvars='',$confirm=true) {

global $_TABLES, $_USER, $LANG_CMI, $_CONF;

if (!SEC_hasRights('cmi.edit')) {
    $display  = COM_siteHeader('menu');
    $display .= COM_startBlock($LANG_CMI[1]);
    $display .= $LANG_CMI[2];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    $msg  = "User {$_USER['username']} tried to access CMI plugin functions ";
    $msg .= "without cmi.edit perms. IP: " . $_SERVER['REMOTE_ADDR'];
    COM_accessLog($msg);
    echo $display;
    exit();
    }

$license_id   = addslashes($pvars['lid']);
$invalid_msg  = COM_siteHeader('menu');
$invalid_msg .= COM_startBlock($LANG_CMI[60]);
$invalid_msg .= $LANG_CMI[61];
$invalid_msg .= COM_endBlock();
$invalid_msg .= COM_siteFooter();

if (!is_array($pvars) or !is_numeric($license_id)) {
    echo $invalid_msg;
    exit();
    }
$count = DB_count($_TABLES['cmi_licenses'],'lid',$license_id);
if (DB_error() or $count != 1) {
    echo $invalid_msg;
    exit();
    }
if ($confirm === true) {
    if ($pvars['submit'] !== "save") {
        echo $invalid_msg;
        exit();
        }
    } else {
    return;
    }

$fields     = $pvars['fields'];
$value_list = array();
if (!is_array($fields) or count($fields) < 1) {
    $display  = COM_siteHeader('menu');
    $display .= COM_startBlock("Error: Invalid Form Data");
    $display .= "The license changes cannot be saved due to invalid ";
    $display .= "form data.";
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    $msg  = "User {$_USER['username']} generated an error when attempting ";
    $msg .= "to edit a license through the CMI plugin.  ";
    $msg .= "IP: {$_SERVER['REMOTE_ADDR']}";
    COM_errorLog($msg);
    echo $display;
    exit();
    }
}

?>
